﻿package  {
	import flash.display.Sprite;
	
	public class BulletContainer extends Sprite {

		public var bullets:Vector.<Bullet>;
		public var cache:Vector.<Bullet>;
		
		public var fade:Boolean = false;
		public var fadeLevel:Number = 1.0;

		public function BulletContainer() {
			bullets = new Vector.<Bullet>();
			cache = new Vector.<Bullet>();
			
		}
		
		public function addBullet(xx:Number, yy:Number, speed:Number, direction:Number):void {
			var b:Bullet;
			if (cache.length > 0) {
				b = cache.pop();
			} else {
				b = new Bullet();
			}
			b.initialize(xx, yy, speed, direction);
			addChild(b);
			bullets.push(b);
		}
		
		public function step():void {
			var i:int;
			var b:Bullet;
			if (fade) {
				fadeLevel -= 0.1;
				if (fadeLevel <= 0) {
					for (i = bullets.length-1; i >= 0; i--) {
						b = bullets.pop();
						b.alpha = 1.0;
						removeChild(b);
						cache.push(b);
					}
					fade = false;
				} else {
					for (i = bullets.length-1; i >= 0; i--) {
						bullets[i].alpha = fadeLevel;
					}
				}
			} else {
				for (i = bullets.length - 1; i >= 0; i--) {
					b = bullets[i];
					if (b.toDestroy) {
						removeChild(b);
						bullets.splice(i, 1);
						cache.push(b);
					} else {
						b.step();
					}
				}
			}
		}
		
		public function fadeOut():void {
			fade = true;
			fadeLevel = 1.0;
		}
	}
	
}
