﻿package  {
	import flash.display.Sprite;
	
	public class EnemyContainer extends Sprite {
		
		public var enemies:Vector.<Enemy>;
		
		public var explosions:ExplosionContainer;
		public var bullets:BulletContainer;
		public var you:You;
		
		public var enemyExploded:Boolean = false;
		public var enemyShot:Boolean = false;
		public var score:int = 0;
		
		public var fade:Boolean = false;
		public var fadeLevel:Number = 1.0;

		public function EnemyContainer() {
			enemies = new Vector.<Enemy>();
		}
		
		public function step():void {
			var i:int;
			enemyExploded = false;
			enemyShot = false;
			if (fade) {
				fadeLevel -= 0.1;
				if (fadeLevel <= 0) {
					for (i = enemies.length-1; i >= 0; i--) {
						removeChild(enemies.pop());
					}
					fade = false;
				} else {
					for (i = enemies.length-1; i >= 0; i--) {
						enemies[i].alpha = fadeLevel;
					}
				}
			} else {
				score = 0;
				for (i = enemies.length - 1; i >= 0; i--) {
					var e:Enemy = enemies[i];
					if (e.toDestroy) {
						removeChild(e);
						enemies.splice(i, 1);
						explosions.addExplosion(e.x, e.y);
						enemyExploded = true;
						score += e.value;
					} else {
						e.step();
					}
					if (e.shot) {
						enemyShot = true;
					}
				}
			}
		}
		
		public function addEnemy(type:int, xx:Number, yy:Number):void {
			var e:Enemy;
			switch(type) {
				case 0:
					e = new EnemySimple(xx, yy);
					break;
				case 1:
					e = new EnemySimple2(xx, yy);
					break;
				case 2:
					e = new EnemyEye(xx, yy);
					break;
				case 3:
					e = new EnemySpew(xx, yy);
					break;
				case 4:
					e = new EnemySnowman(xx, yy);
					break;
				case 5:
					e = new EnemyFollower(xx, yy);
					break;
				default:
					e = new Enemy(xx, yy);
					break;
			}
			e.bullets = bullets;
			e.you = you;
			addChild(e);
			enemies.push(e);
		}
		
		public function fadeOut():void {
			fade = true;
			fadeLevel = 1.0;
		}

	}
	
}
