﻿package  {
	import flash.display.MovieClip;
	
	public class GameObject extends MovieClip {
		
		public var xx:Number = 0;
		public var yy:Number = 0;
		
		public var xvel:Number = 0;
		public var yvel:Number = 0;
		
		public var xaccel:Number = 0;
		public var yaccel:Number = 0;
		
		public var turn:Number = 0;
		
		public var maxSpeed:Number = 10000;
		
		public var speed:Number = 0;
		public var direction:Number = 0;
		
		public var xmin:Number = 0;
		public var xmax:Number = 700;
		public var ymin:Number = 0;
		public var ymax:Number = 550;
		
		public var bounces:Boolean = false;
		public var stayInBounds:Boolean = true;
		public var radius:Number = 0;


		public function GameObject() {
		}
		
		public function initialize(xstart:Number, ystart:Number, speed:Number, direction:Number):void {
			xx = xstart;
			yy = ystart;
			xvel = speed * Math.cos(Math.PI/180.0 * direction);
			yvel = -speed * Math.sin(Math.PI/180.0 * direction);
			this.speed = speed;
			this.direction = direction;
			x = xx;
			y = yy;
			
			xmin = radius + 4;
			xmax = 700 - radius - 4;
			ymin = radius + 4;
			ymax = 550 - radius - 4;
		}
		
		public function step():void {
			xvel += xaccel;
			yvel += yaccel;
			speed = Math.sqrt(xvel*xvel + yvel*yvel);
			direction = Math.atan2(-yvel, xvel) * 180.0/Math.PI;
			
			if (speed > maxSpeed) {
				xvel = maxSpeed / speed * xvel;
				yvel = maxSpeed / speed * yvel;
			}
			
			if (turn != 0) {
				direction += turn;
				setVelocity(speed, direction);
			}
			
			xx += xvel;
			yy += yvel;
			
			if (stayInBounds) {
				if (xx < xmin) {
					xx = xmin;
					if (bounces) {
						xvel = Math.abs(xvel);
					} else {
						xvel = 0;
					}
				}
				if (xx > xmax) {
					xx = xmax;
					if (bounces) {
						xvel = -Math.abs(xvel);
					} else {
						xvel = 0;
					}
				}
				if (yy < ymin) {
					yy = ymin;
					if (bounces) {
						yvel = Math.abs(yvel);
					} else {
						yvel = 0;
					}
				}
				if (yy > ymax) {
					yy = ymax;
					if (bounces) {
						yvel = -Math.abs(yvel);
					} else {
						yvel = 0;
					}
				}
			}
			
			x = xx;
			y = yy;
			
		}
		
		public function setSpeed(speed:Number):void {
			xvel = speed * Math.cos(Math.PI/180.0 * direction);
			yvel = -speed * Math.sin(Math.PI/180.0 * direction);
		}
		
		public function setDirection(direction:Number):void {
			xvel = speed * Math.cos(Math.PI/180.0 * direction);
			yvel = -speed * Math.sin(Math.PI/180.0 * direction);
		}
		
		public function setVelocity(speed:Number, direction:Number):void {
			xvel = speed * Math.cos(Math.PI/180.0 * direction);
			yvel = -speed * Math.sin(Math.PI/180.0 * direction);
		}
		
		public function collides(x1:Number, y1:Number, additionalRadius:Number = 0):Boolean {
			var dx:Number = xx - x1;
			var dy:Number = yy - y1;
			var r2:Number = additionalRadius + radius;
			return dx*dx + dy*dy < r2*r2;
		}

	}
	
}
