﻿package  {
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.KeyboardEvent;
	import flash.events.MouseEvent;
	import flash.media.Sound;
	import flash.media.SoundTransform;
	import flash.media.SoundChannel;
	import flash.net.SharedObject;

	public class Main extends MovieClip {
		
		public var active:Boolean = false;
		public var startZone:MovieClip;
		public var title:MovieClip;
		public var instructions:MovieClip;
		
		public var bestScore:int = 0;
		
		public var scoreStatus:ScoreStatus;
		
		public var you:You;
		public var shootCooldown:int = 0;
		public var health:int = 3;
		public var score:int = 0;
		public var invincibilityTTL:int = 0;
		public var restartTTL:int = 0;
		
		
		public var difficulty:int = 0;
		public var difficultyTTL:int = 0;
		public var lockedSpawn:int = -1;
		public var spawnCooldown:int = 0;
		public var swarmCooldown:int = 0;
		
		public var originalSpawnList:Array = [0, 0, 0, 1];
		public var spawnList:Array;
		public var futureSpawnList:Array = [2, 5, 3, 1, 2, 3, 4, 5, 4];
		
		
		public var enemies:EnemyContainer;
		public var yourBullets:YourBulletContainer;
		public var explosions:ExplosionContainer;
		public var bullets:BulletContainer;
		public var status:Status;
		
		public var keyState:Object = {'left': false, 'right': false, 'up': false, 'down': false,
									  'left2': false, 'right2': false, 'up2': false, 'down2': false,
									  'mute': false, 'musicmute': false};
		public var mouseState:Boolean = false;
		
		public var soundsOn:Boolean = true;
		public var musicOn:Boolean = true;
		public var soundShoot1:Sound;
		public var soundExplode:Sound;
		public var soundEnemyHit:Sound;
		public var soundYouHit:Sound;
		public var soundEnemyShoot:Sound;
		public var soundSpawn:Sound;
		public var soundMusic:Sound;
		public var musicChannel:SoundChannel;
		public var musicTransform:SoundTransform;
		
		public var enemyHit:Boolean = false;

		public function Main() {
			you = new You();
			enemies = new EnemyContainer();
			yourBullets = new YourBulletContainer();
			explosions = new ExplosionContainer();
			bullets = new BulletContainer();
			enemies.explosions = explosions;
			enemies.bullets = bullets;
			enemies.you = you;
			status = new Status();
			startZone = new StartZone();
			title = new Title();
			instructions = new Instructions();
			scoreStatus = new ScoreStatus();
			
			status.visible = false;
			active = false;
			
			you.xx = 150;
			you.yy = 475;
			startZone.x = 350;
			startZone.y = 265;
			instructions.x = 450;
			instructions.y = 450;
			scoreStatus.x = 195;
			scoreStatus.y = 80;
			scoreStatus.lastScoreLabel.visible = false;
			scoreStatus.lastScoreText.visible = false;
			scoreStatus.newRecord.visible = false;
			
			addChild(instructions);
			addChild(scoreStatus);
			addChild(startZone);
			addChild(yourBullets);
			addChild(you);
			addChild(enemies);
			addChild(explosions);
			addChild(bullets);
			addChild(status);
			addChild(title);
			
			
			//
			addEventListener(Event.ENTER_FRAME, step);
			stage.addEventListener(KeyboardEvent.KEY_DOWN, keyboardDown);
			stage.addEventListener(KeyboardEvent.KEY_UP, keyboardUp);
			stage.addEventListener(MouseEvent.MOUSE_DOWN, mouseButtonDown);
			stage.addEventListener(MouseEvent.MOUSE_UP, mouseButtonUp);
			
			soundShoot1 = new SoundShoot1();
			soundExplode = new SoundExplode();
			soundEnemyHit = new SoundEnemyHit();
			soundYouHit = new SoundYouHit();
			soundEnemyShoot = new SoundEnemyShoot();
			soundSpawn = new SoundSpawn();
			soundMusic = new SoundMusic();
			musicTransform = new SoundTransform(0.5);
			
			var save:SharedObject = SharedObject.getLocal("ArenaHell");
			if (save.data.bestScore != undefined) {
				bestScore = save.data.bestScore;
			} else {
				bestScore = 0;
			}
			scoreStatus.bestScoreText.text = "" + bestScore;
			
			spawnList = originalSpawnList.slice();
		}
		
		public function step(e:Event):void {
			if (restartTTL == 0) {
				handleYouInput();
				handleYouShoot();
			}
			you.gun.rotation = directionTo(you.xx, -you.yy, mouseX, -mouseY);
			you.step();
			yourBullets.step();
			enemies.step();
			bullets.step();
			explosions.step();
			if (!active) {
				handleStart();
			}
			if (active) {
				handleEnemySpawn();
				checkCollisions();
			}
			updateText();
			invincibilityTTL--;
			if (invincibilityTTL%2 == 1 ) {
				you.alpha = 0.85;
			} else {
				you.alpha = 1;
			}
			
			score += enemies.score;
			if (enemies.enemyExploded) {
				playSound(soundExplode);
			}
			if (enemies.enemyShot) {
				playSound(soundEnemyShoot);
			}
			if (enemyHit) {
				playSound(soundEnemyHit);
			}
			
			if (health <= 0 && active) {
				gameOver();
			}
			if (restartTTL > 0) {
				restartTTL--;
				if (restartTTL == 0) {
					title.visible = true;
					you.visible = true;
					startZone.visible = true;
					instructions.visible = true;
					you.xx = 175;
					you.yy = 475;
				}
			}
		}
		
		public function handleYouInput():void {
			you.xaccel = 0;
			you.yaccel = 0;
			var moved:Boolean = false;
			if (keyState['left'] || keyState['left2']) {
				you.xaccel -= 2;
				moved = true;
			}
			if (keyState['right'] || keyState['right2']) {
				you.xaccel += 2;
				moved = true;
			}
			if (keyState['up'] || keyState['up2']) {
				you.yaccel -= 2;
				moved = true;
			}
			if (keyState['down'] || keyState['down2']) {
				you.yaccel += 2;
				moved = true;
			}
			if (!moved) {
				you.setSpeed(Math.max(you.speed - 4, 0));
			}
		}
		
		public function handleYouShoot():void {
			if (shootCooldown <= 0) {
				if (mouseState) {
					var directionRad:Number = directionToRad(you.x, you.y, mouseX, mouseY);
					yourBullets.addBullet(you.xx + 18*Math.cos(directionRad), you.yy - 18*Math.sin(directionRad), 14, directionRad*180.0/Math.PI);
					shootCooldown = 3;
					playSound(soundShoot1);
				}
			} else {
				shootCooldown--;
			}
		}
		
		public function handleEnemySpawn():void {
			var spawned:Boolean = false;
			var type:int = 0;
			if (spawnCooldown <= 0) {
				if (lockedSpawn >= 0) {
					type = lockedSpawn;
				} else {
					var r:int = int(Math.random() * spawnList.length);
					type = spawnList[r];
				}
				spawnEnemy(type);
				spawned = true;
				spawnCooldown = 13+enemies.enemies.length;
			} else {
				spawnCooldown--;
			}
			
			if (swarmCooldown <= 22) {
				//lockedSpawn = 0;
				if (spawnCooldown > 1) {
					spawnCooldown = 1;
				}
			}
			if (swarmCooldown <= 24 || Math.random()*enemies.enemies.length < 9) {
				swarmCooldown--;
			}
			if (swarmCooldown == 0) {
				lockedSpawn = -1;
				swarmCooldown = 200;
			}
			
			if (spawned) {
				playSound(soundSpawn);
			}
			
			difficultyTTL--;
			if (difficultyTTL <= 0) {
				if (difficulty < futureSpawnList.length) {
					spawnList.push(futureSpawnList[difficulty]);
				}
				difficulty++;
				difficultyTTL = 300;
			}
		}
		
		public function spawnEnemy(type:int):void {
			var flag:Boolean = true;
			var xx:Number;
			var yy:Number;
			while(flag) {
				xx = Math.random()*650+25;
				yy = Math.random()*500+25;
				if ((xx-you.x)*(xx-you.x) + (yy-you.y)*(yy-you.y) < 100*100) {
					flag = true;
				} else {
					flag = false;
				}
			}
			enemies.addEnemy(type, xx, yy);
			explosions.addExplosion(xx, yy, 1);
		}
		
		public function checkCollisions():void {
			enemyHit = false;
			for (var i:int = 0; i < enemies.enemies.length; i++) {
				var e:Enemy = enemies.enemies[i];
				for (var j:int = 0; j < yourBullets.bullets.length; j++) {
					var b:YourBullet = yourBullets.bullets[j];
					if (e.collides(b.x, b.y, 2)) {
						e.hp--;
						if (e.hp > 0) {
							enemyHit = true;
						}
						b.toDestroy = true;
					}
				}
				if (e.collides(you.x, you.y, 2)) {
					e.hp -= 5;
					if (invincibilityTTL <= 0) {
						health -= 1;
						invincibilityTTL = 40;
						playSound(soundYouHit);
					}
				}
			}
			
			for (i = 0; i < bullets.bullets.length; i++) {
				var bb:Bullet = bullets.bullets[i];
				if (bb.collides(you.x, you.y, 2)) {
					if (invincibilityTTL <= 0) {
						health -= 1;
						invincibilityTTL = 40;
						playSound(soundYouHit);
						
					}
					bb.toDestroy = true;
				}
			}
		}
		
		public function updateText():void {
			status.healthText.text = "Health: " + health;
			status.scoreText.text = "Score: " + score;
		}
		
		public function handleStart():void {
			var dx:Number = you.x - startZone.x;
			var dy:Number = you.y - startZone.y;
			if (dx*dx + dy*dy < 35*35) {
				active = true;
				status.visible = true;
				startZone.visible = false;
				title.visible = false;
				instructions.visible = false;
				health = 4;
				score = 0;
				scoreStatus.visible = false;
				if (soundsOn && musicOn) {
					musicChannel = soundMusic.play(0, 999999, musicTransform);
				}
				
				difficulty = 0;
				spawnCooldown = 16;
				swarmCooldown = 100;
				difficultyTTL = 100;
				spawnList = originalSpawnList.slice();
			}
		}
		
		public function gameOver():void {
			active = false;
			status.visible = false;
			enemies.fadeOut();
			bullets.fadeOut();
			you.visible = false;
			restartTTL = 50;
			scoreStatus.visible = true;
			scoreStatus.lastScoreLabel.visible = true;
			scoreStatus.lastScoreText.visible = true;
			scoreStatus.lastScoreText.text = "" + score;
			
			scoreStatus.newRecord.visible = false;
			if (score > bestScore) {
				bestScore = score;
				scoreStatus.newRecord.visible = true;
				var save:SharedObject = SharedObject.getLocal("ArenaHell");
				save.data.bestScore = bestScore;
			}
			scoreStatus.bestScoreText.text = "" + bestScore;
			you.xx = 175;
			you.yy = 475;
			you.xvel = 0;
			you.yvel = 0;
			you.xaccel = 0;
			you.yaccel = 0;
			
			musicChannel.stop();
		}
		
		public function keyboardDown(e:KeyboardEvent):void {
			switch(e.keyCode) {
				case 37:
					keyState['left'] = true;
					break;
				case 38:
					keyState['up'] = true;
					break;
				case 39:
					keyState['right'] = true;
					break;
				case 40:
					keyState['down'] = true;
					break;
					
				case 87:
					keyState['up2'] = true;
					break;
				case 65:
					keyState['left2'] = true;
					break;
				case 68:
					keyState['right2'] = true;
					break;
				case 83:
					keyState['down2'] = true;
					break;
					
				case 77:
					if (!keyState['mute']) {
						soundsOn = !soundsOn;
					}
					keyState['mute'] = true;
					break;
			}
		}
		
		public function keyboardUp(e:KeyboardEvent):void {
			switch(e.keyCode) {
				case 37:
					keyState['left'] = false;
					break;
				case 38:
					keyState['up'] = false;
					break;
				case 39:
					keyState['right'] = false;
					break;
				case 40:
					keyState['down'] = false;
					break;
					
				case 87:
					keyState['up2'] = false;
					break;
				case 65:
					keyState['left2'] = false;
					break;
				case 68:
					keyState['right2'] = false;
					break;
				case 83:
					keyState['down2'] = false;
					break;
				case 77:
					keyState['mute'] = false;
					break;
			}
		}
		
		public function mouseButtonDown(e:MouseEvent):void {
			mouseState = true;
		}
		
		public function mouseButtonUp(e:MouseEvent):void {
			mouseState = false;
		}

		public function directionTo(x1:Number, y1:Number, x2:Number, y2:Number):Number {
			return Math.atan2(y1-y2, x2-x1)*180.0/Math.PI;
		}
		
		public function directionToRad(x1:Number, y1:Number, x2:Number, y2:Number):Number {
			return Math.atan2(y1-y2, x2-x1);
		}
		
		public function playSound(s:Sound):void {
			if (soundsOn) {
				s.play();
			}
		}

	}
	
}
